﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Motorcycle
{
    class Handler
    {
        private string motName;
        private Motorcycle mot;
        private Money money = new Money();

        public Handler()
        {
            motName = "NaN";
        }

        #region startUp
        public void startUp()
        {
            Console.Clear();
            Console.WriteLine("===============================================================================");
            Console.WriteLine(" /$$      /$$             /$$                        ");
            Console.WriteLine("| $$$    /$$$            | $$                        ");
            Console.WriteLine("| $$$$  /$$$$  /$$$$$$  /$$$$$$    /$$$$$$   /$$$$$$ ");
            Console.WriteLine("| $$ $$/$$ $$ /$$__  $$|_  $$_/   /$$__  $$ /$$__  $$");
            Console.WriteLine(@"| $$  $$$| $$| $$  \ $$  | $$    | $$  \ $$| $$  \__/");
            Console.WriteLine(@"| $$\  $ | $$| $$  | $$  | $$ /$$| $$  | $$| $$      ");
            Console.WriteLine(@"| $$ \/  | $$|  $$$$$$/  |  $$$$/|  $$$$$$/| $$      ");
            Console.WriteLine(@"|__/     |__/ \______/    \___/   \______/ |__/      ");
            Console.WriteLine("");
            Console.WriteLine("");
            Console.WriteLine("  /$$$$$$                      /$$           /$$  ");
            Console.WriteLine(" /$$__  $$                    | $$          | $$    ");
            Console.WriteLine(@"| $$  \__/ /$$   /$$  /$$$$$$$| $$  /$$$$$$ | $$     ");
            Console.WriteLine("| $$      | $$  | $$ /$$_____/| $$ /$$__  $$| $$   ");
            Console.WriteLine("| $$      | $$  | $$| $$      | $$| $$$$$$$$|__/    ");
            Console.WriteLine("| $$    $$| $$  | $$| $$      | $$| $$_____/         ");
            Console.WriteLine("|  $$$$$$/|  $$$$$$$|  $$$$$$$| $$|  $$$$$$$ /$$     ");
            Console.WriteLine(@" \______/  \____  $$ \_______/|__/ \_______/|__/     ");
            Console.WriteLine("           /$$  | $$                                ");
            Console.WriteLine("          |  $$$$$$/                                 ");
            Console.WriteLine(@"           \______/                                  ");
            Console.WriteLine("===============================================================================");
            Console.Beep(900, 880);
            Console.Beep(670, 700);
            Console.Beep(470, 850);
            Console.Beep(900, 880);
            Console.Beep(1200, 880);
            Console.Clear();
            Console.WriteLine("Hey! Do you want a motorcycle? Give it a name!");
            motName = Console.ReadLine();
            checkName();
        }
        #endregion

        private void checkName()
        {
            if (motName == "" || motName == " ")
            {
                Console.Clear();
                Console.WriteLine("that's no name! give it a new name please!");
                motName = Console.ReadLine();
                checkName();
            }
            else
            {
                mot = new Motorcycle(motName);
                whatToDo();
            }
        }

        public void whatToDo()
        {
            Console.Clear();
            Console.WriteLine("Money: " + money.getMoney().ToString());
            Console.WriteLine("What do you want to do with your motorcycle?" + System.Environment.NewLine + System.Environment.NewLine + System.Environment.NewLine);
            Console.WriteLine("Press 1 to view your motorcycle.");
            Console.WriteLine("Press 2 to race with your motorcycle.");
            Console.WriteLine("Press 3 to upgrade your motorcycle.");
            Console.WriteLine("Press P to save your motorcycle.");
            Console.WriteLine("Press any other key to quit.");

            if (money.getMoney() < 0)
            {
                gameOver("You have made debts!");
            }

            //check de stuff.
            ConsoleKeyInfo key = Console.ReadKey();
            if (key.Key == ConsoleKey.D1)
            {
                viewCycle();
            }
            if (key.Key == ConsoleKey.D2)
            {
                raceWithOpponents();
            }
            if (key.Key == ConsoleKey.D3)
            {
                upgradeCycle();
            }
            if (key.Key == ConsoleKey.P)
            {
                saveCycle();
            }
            if (key.Key == ConsoleKey.F1)
            {
                money.addMoney(100000000);
                whatToDo();
            }
        }

        public void gameOver(string arg)
        {
            Console.Clear();
            Console.Beep(500, 500);
            Console.Beep(400, 408);
            Console.Beep(600, 709);
            Console.WriteLine("===============================================================================");
            Console.WriteLine("===                                 GAME OVER                               ===");
            Console.WriteLine("===============================================================================");
            Console.WriteLine("You lost the game!");
            Console.Write("Reason: " + arg + System.Environment.NewLine + System.Environment.NewLine);
            Console.WriteLine("Press any key to quit.");
            Console.ReadKey();
        }
        public void viewCycle()
        {
            Console.Clear();
            mot.printCycle();
            Console.Beep();
            Console.ReadKey();
            whatToDo();
        }

        public void saveCycle()
        {
            Console.Clear();
            string path = string.Format(@"{0}\{1}.txt", System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().Location), motName);
            try
            {
                if (!System.IO.File.Exists(path))
                {
                    using (var file = System.IO.File.Create(path))
                    {
                        file.Close();
                    }
                }

                using (var writer = new System.IO.StreamWriter(path))
                {
                    writer.Write(mot.getStringCycle() + System.Environment.NewLine + "Total money: " + money.getMoney().ToString());
                    writer.Close();
                }

                Console.WriteLine("Motorcycle saved! Press a key to return.");
                Console.Beep();
                Console.ReadKey();
                whatToDo();
            }
            catch
            {
                Console.WriteLine("Whoop! Something went wrong! Press a key to return.");
                Console.ReadKey();
                whatToDo();
            }
        }

        #region stuff with racing
        private string w1 = "Awsome;Disabled;Stupid;Pleasant;Drunken;Born;Undead;Loved;Inspired;Eaten;Rotten;Fresh;Crazy;Happy;Sleepy;Car Driving;Flying;Running";
        private string w2 = "Nerds;Rockers;Racers;Zombies;Dressed Freaks;Gohtics;Skateboarders;Harley Drivers;Robots;Assholes;Idiots;Fruit Eaters;Pirates;Ghosts;Pancakes;Wheelchairs;Hippys";
        private int reward = 0;
        private int crashChance = 0;
        private int winChance = 0;
        private int repair = 0;
        private int lost = 0;
        private string oppTeam;

        Team teamEasy;
        Team teamMed;
        Team teamHard;

        public void raceWithOpponents()
        {
            Console.Clear();
            Console.WriteLine("Against who want you to race?");
            teamEasy = new Team();
            teamMed = new Team();
            teamHard = new Team();

            Random ran1 = new Random();
            Random easy = new Random(ran1.Next(0, 894325707));
            Random med = new Random(ran1.Next(0, 579837029));
            Random hard = new Random(ran1.Next(0, 156354754));

            teamEasy.nameOfTeam = "The " + getw1(easy) + " " + getw2(easy);
            teamMed.nameOfTeam = "The " + getw1(med) + " " + getw2(med);
            teamHard.nameOfTeam = "The " + getw1(hard) + " " + getw2(hard);

            Console.WriteLine("[1]: " + teamEasy.nameOfTeam + " (easy)");
            Console.WriteLine("[2]: " + teamMed.nameOfTeam + " (medium)");
            Console.WriteLine("[3]: " + teamHard.nameOfTeam + " (hard)");
            Console.WriteLine("[4]: Abort race and return");

            ConsoleKeyInfo key = Console.ReadKey();
            if (key.Key == ConsoleKey.D1)
            {
                setEasyRace();
                race();
            }
            if (key.Key == ConsoleKey.D2)
            {
                setMedRace();
                race();
            }
            if (key.Key == ConsoleKey.D3)
            {
                setHardRace();
                race();
            }
            if (key.Key == ConsoleKey.D4)
            {
                whatToDo();
            }
        }

        string getw1(Random rand)
        {
            string[] w = w1.Split(';');
            return w[rand.Next(0, w.Length - 1)];
        }

        string getw2(Random rand)
        {
            string[] w = w2.Split(';');
            return w[rand.Next(0, w.Length - 1)];
        }

        void setEasyRace()
        {
            oppTeam = teamEasy.nameOfTeam;
            reward = 50;
            crashChance = 19;
            winChance = 41;
            repair = 13;
            lost = 5;
        }
        void setMedRace()
        {
            oppTeam = teamMed.nameOfTeam;
            reward = 100;
            crashChance = 32;
            winChance = 61;
            repair = 34;
            lost = 10;
        }
        void setHardRace()
        {
            oppTeam = teamHard.nameOfTeam;
            reward = 200;
            crashChance = 56;
            winChance = 81;
            repair = 70;
            lost = 25;
        }
        void race()
        {
            Console.Clear();
            Console.WriteLine("Racing against " + oppTeam + "...");
            Console.Beep(2000, 1000);
            Random rand = new Random();
            int r = rand.Next(0, 99);
            if (r > crashChance)
            {
                if (r > winChance)
                {
                    Console.Clear();
                    Console.WriteLine("You won! Your opponent " + oppTeam + " are very sad.");
                    Console.WriteLine("You were rewarded! You got: " + reward.ToString());
                    money.addMoney(reward);
                    Console.Beep(2000, 1000);
                }
                else
                {
                    Console.Clear();
                    Console.WriteLine("You lost: " + lost + ". Better luck next time.");
                    money.addMoney(-lost);
                    Console.Beep(500, 1000); 
                }
            }
            else
            {
                Console.Clear();
                Console.WriteLine("You crashed! Bad luck! Repair costs: " + repair.ToString());
                money.addMoney(-repair);
                Console.Beep(500, 1000); 
            }
            Console.ReadKey();
            whatToDo();
        }
        #endregion
        #region stuff with upgrading
        void upgradeCycle()
        {
            Console.Clear();
            Console.WriteLine("[1] to upgrade your top speed by 20. Cost: 100");
            Console.WriteLine("[2] if you want to return.");

            ConsoleKeyInfo key = Console.ReadKey();
            if (key.Key == ConsoleKey.D1)
            {
                int mTemp = money.getMoney();
                if (mTemp < 100)
                {
                    Console.Clear();
                    Console.WriteLine("You don't have enough money for that.");
                    Console.ReadKey();
                    whatToDo();
                }
                else
                {
                    money.addMoney(-100);
                    mot.addSpeed(20);
                    mot.addHorsePower(20);
                    Console.Clear();
                    string tempString = mot.getSpeed();
                    string tempString2 = mot.getHorsePower();
                    Console.WriteLine("You have upgraded your speed! Your speed is now: " + tempString);
                    Console.WriteLine("Your horsepower is now: " + tempString2);
                    Console.Beep();
                    Console.ReadKey();
                    whatToDo();
                }
            }

            if (key.Key == ConsoleKey.D2)
            {
                whatToDo();
            }
        }
        #endregion
    }
}
